﻿using System;
using System.Windows.Forms;
using Infragistics.Win.UltraWinListView;

namespace UltraListViewTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            for (int i = 0; i < 10; i++)
            {
                var listItem = new ListItem(string.Format("List Item {0}", i + 1));
                ultraListView1.Items.Add(new UltraListViewItem(listItem, null, listItem));
            }
            ultraListView1.SelectedItems.Add(ultraListView1.Items[0]);
        }

        private void ultraListView1_ItemSelectionChanged(object sender, ItemSelectionChangedEventArgs e)
        {
            if (e.SelectedItems.Count > 0)
            {
                ultraTextEditor1.Text = e.SelectedItems[0].Value.ToString();
            }
        }

        private void ultraTextEditor1_TextChanged(object sender, EventArgs e)
        {
            if (ultraListView1.SelectedItems.Count > 0)
            {
                ((ListItem) ultraListView1.SelectedItems[0].Value).DisplayText = ultraTextEditor1.Text;

                // Note: comment out following 3 lines to disable the klude that makes the rename work
                var selectedItem = ultraListView1.SelectedItems.First;
                ultraListView1.SelectedItems.Clear();
                ultraListView1.SelectedItems.Add(selectedItem);
            }
        }
    }

    internal class ListItem
    {
        public ListItem(string displayText)
        {
            DisplayText = displayText;
        }

        public string DisplayText { get; set; }

        public override string ToString()
        {
            return DisplayText;
        }
    }
}
